<template>
    <el-dialog :visible.sync="show" v-on:update:visible="updateShowDialog" class="modalGridPreliminary padding_10" :custom-class="nameClass" width="600px">
        <div>
            <!-- <p style="color: #4A4A4A"><strong>COPIAR A LA SEMANA:</strong></p> -->
            <p class="text-orange font_size_18 text-center"><strong>COPIAR PARRILLA</strong></p>
            <!-- <p v-html="textTitle"></p> -->
            
            <div class="d_flex space_around align_items margin_top_40">
                <p v-html="textTitle" style="width: 300px; line-height: 25px;"></p>
                <el-date-picker
                    class="date-head"
                    v-model="dateSearch"
                    type="date"
                    format="dd/MM/yyyy"
                    value-format="timestamp"
                    placeholder="Escoja una semana"
                    :picker-options="pickerOptions"
                    @input="setWeek">
                </el-date-picker>
            </div>
            <div class="d_flex f_end">
                <el-button @click="$emit('eventBtn')" style="margin-top: 3rem" :type="typeBtn1" plain > CANCELAR </el-button>   
                <el-button @click="$emit('btnEvent', dateString)" style="margin-top: 3rem" :type="typeBtn1" :disabled="isAbled || isBlockBtn"> COPIAR </el-button>
            </div>
        </div>
    </el-dialog>
</template>

<script>
    import { convertDate, getFirstDay } from '@/utils/calculateTime.js'
    import { months } from '@/enums.js'

    export default {
        name: 'ModalGridPreliminary',
        props: {
            showDialog: Boolean,
            nameClass: String,
            week: String,
            typeBtn1: {
                type: String,
                required: false
            },
            
        },
        data() {
            return {
                show: this.showDialog,
                dateString: '',
                dateSearch: '',
                firstDayOfWeek: '',
                firstDay: '',
                secondDay: '',
                thirdDay: '',
                fourthDay: '',
                fifthDay: '',
                sixthDay: '',
                lastDay: '',
                month: '',
                year: '',
                startDate: '',
                endDate: '',
                month2: '',
                year2: '',
                pickerOptions: {
                    disabledDate: this.disabledDays
                },
            }
        },
        methods: {
            updateShowDialog(isVisible) {
                if (isVisible) return false;
                this.$emit('update:showDialog', false )
            },
            setWeek() {
                if(this.dateSearch === '' || this.dateSearch === null) {
                  this.firstDayOfWeek = getFirstDay(new Date())
                  this.startDate = getFirstDay(new Date())
                } else {
                  this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch))
                  this.startDate = getFirstDay(new Date(this.dateSearch))
                }
                
                this.firstDay = this.firstDayOfWeek.getDate()
                let data = [{name: 'secondDay', num: 1}, {name: 'thirdDay', num: 2}, {name: 'fourthDay', num: 3}, {name: 'fifthDay', num: 4}, {name: 'sixthDay', num: 5}, {name: 'lastDay', num: 6}]

                data.forEach((e) => {
                  this[e.name] = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000) * e.num).getDate()
                })

                this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))
                this.month = months[this.firstDayOfWeek.getMonth()]
                this.month2 = months[this.endDate.getMonth()]
                this.year = this.firstDayOfWeek.getFullYear()
                this.year2 = this.endDate.getFullYear()
                this.dateString = this.getWeekText()
                this.$emit('firstDayThisWeek', this.firstDayOfWeek)
            },
            getWeekText() {
                let text
                if (this.month == this.month2 && this.year == this.year2  ) {
                    text = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
                }
                else if (this.month !== this.month2 && this.year == this.year2 ) {
                    text = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
                }
                else if (this.month !== this.month2 && this.year !== this.year2) {
                    text = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
                }
                return text
            },
            disabledDays(time) {},
        },
        computed: {
            isAbled() {
                if(this.dateSearch === '' || this.dateSearch == null) {
                    return true
                } else {
                    return false
                }
            },
            isSelectWeek() {
                if(this.dateSearch === '' || this.dateSearch == null) {
                    return ''
                } else {
                    return this.dateString
                }
            },
            textTitle() {
                let conditional = this.isSelectWeek == '' ? '' : ` </br><strong style="color: #18974E">${this.isSelectWeek}</strong>`
                
                return `La parrilla de la </br><strong>${this.week}</strong> </br>se copiará a la${conditional}.`
            },

            isBlockBtn() {
                if(this.week  === this.isSelectWeek) {
                    return true
                } else {
                    return false
                }
            }
        },
        created(){
        }
    };
</script>
<style lang="css">
    .modalGridPreliminary .margin_top_40 {
        margin-top: 40px;
    }
    .modalGridPreliminary .d_flex {
        display: flex;
    }
    .modalGridPreliminary .space_around {
        justify-content: space-around;
    }
    .modalGridPreliminary .f_end {
        justify-content: flex-end;
    }
    .padding_10 {
        padding: 10px;
    }
    .font_size_18 {
        font-size: 18px;
    }
    .width_600 {
        width: 600px;
    }
    .align_items {
        align-items: center;
    }
</style>